#############################################################################
##  
##  PackageInfo.g                  NQL                          Rene Hartung 
##  
#H   @(#)$Id: PackageInfo.g,v 1.13 2007/06/18 12:30:53 gap Exp $ 
##
##  Based on Frank Luebeck's template for PackageInfo.g.
##  

SetPackageInfo( rec(

PackageName := "NQL",
Subtitle := "Nilpotent Quotients of L-Presented Groups",
Version := "0.03",
Date    := "18/06/2007",

Persons := [
  rec(
  LastName      := "Hartung",
  FirstNames    := "Rene",
  IsAuthor      := true,
  IsMaintainer  := true,
  Email         := "r.hartung [ed] tu-braunschweig.de",
  WWWHome       := "http://www-public.tu-bs.de:8080/~y0019492/",
  PostalAddress := Concatenation( "TU Braunschweig\n",
                                  "Institute for Computational Mathematics \n",
                                  "Pockelstrasse 14\n",
                                  "38106 Braunschweig\n",
                                  "Germany" ),
  Place         := "Braunschweig, Germany",
  Institution   := "Institute for Computational Mathematics, TU Braunschweig"
  )
],

Status         := "deposited",
#CommunicatedBy := "Alexander Konovalov",
#AcceptDate     := "",

PackageWWWHome := "http://www-public.tu-bs.de:8080/~y0019492/pub/nql/",

ArchiveFormats := ".tar.gz",
ArchiveURL     := Concatenation( ~.PackageWWWHome, "nql-",~.Version),
README_URL     := Concatenation( ~.PackageWWWHome, "README" ),
PackageInfoURL := Concatenation( ~.PackageWWWHome, "PackageInfo.g" ),

AbstractHTML   := Concatenation( 
               "The NQL Package defines new GAP objects to work with ",
               "L-presented groups. The main part of the package is a ",
               "nilpotent quotient algorithm for L-presented groups. ",
               "That is an algorithm which takes as input an L-presented ",
               "group L and a positive integer c. It computes a polycyclic ",
               "presentation for the lower central series quotient ",
               "L/gamma_c(L)."),

                  
PackageDoc := rec(
  BookName  := "NQL",
  ArchiveURLSubset := [ "doc", "htm" ],
  HTMLStart := "htm/chapters.htm",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "Nilpotent Quotient Algorithm for L-presented Groups",
  Autoload  := true
),

AvailabilityTest := function()
    return true;
end,

Dependencies := rec(
  GAP                    := ">= 4.4",
  NeededOtherPackages    := [ ["polycyclic", ">= 1.0"] ],
  SuggestedOtherPackages := [ ],
  ExternalConditions     := [ ]
),

Autoload := false,

Keywords := [ "nilpotent quotient algorithm",
              "nilpotent presentations",
              "L-presented groups",
              "infinite presentations   ",
              "commutators",
              "lower central series",
              "nilpotent Engel groups",
              "computational" ]
));
