############################################################################
##
#W misc.gi			NQL				Rene Hartung
##
#H   @(#)$Id: misc.gi,v 1.2 2007/04/23 12:57:58 gap Exp $
##

############################################################################
##
#F IsZeroVector ( <ev> )
##
IsZeroVector:=function(v)
local i;

for i in [1..Length(v)] do 
  if not v[i]=0 then 
    return(false);
  fi;
od;
return(true);
end;

############################################################################
##
#M GeneratorsOfGroup ( <coll> )
##
InstallOtherMethod(GeneratorsOfGroup,
   "for from the left collectors",
   [IsFromTheLeftCollectorRep],0,
   function(ftl)
   return(List([1..NumberOfGenerators(ftl)],
               x->PcpElementByGenExpList(ftl,[x,1])));
   end);

############################################################################
##
#M  WordsOfLengthAtMostN( <list>, <n> )
##   
##  returns a list of all words of <list> of length at most <n>
##
WordsOfLengthAtMostN:=function ( list, n )
  local Words,	# list of all words
	i,g;	# loop variables

  Words:=[[list[1]^0],list];
  for i in [3..n+1] do 
    Add(Words,[]);
    for g in list do 
      Append(Words[i],List(Words[i-1],x->x*g));
    od;
  od;
  return(Concatenation(Words));
  end;
