############################################################################
##
#W nq.gd			NQL				Rene Hartung
##
#H   @(#)$Id: nq.gd,v 1.3 2007/02/28 12:52:21 gap Exp $
##

############################################################################
##
#I InfoClass
##
DeclareInfoClass( "InfoNQL" );

############################################################################
##
#O  NilpotentQuotientLpGroup( <LpGroup>, <c>)
##
DeclareOperation("NilpotentQuotientLpGroup",[IsLpGroup,IsPosInt]);

############################################################################
##
#O  NqEpimorphismNilpotentQuotientLpGroup( <LpGroup>, <c>)
##
DeclareOperation("NqEpimorphismNilpotentQuotientLpGroup",[IsLpGroup,IsPosInt]);

############################################################################
##
#A  NilpotentQuotientSystem ( <LpGroup> )
##
## The largest nilpotent quotient system that has been computed by 
## NilpotentQuotient. For non-invariant L-presented groups the nilpotent
## quotient system of the corresponding ascending L-presentation is 
## stored. 
##
DeclareAttribute( "NilpotentQuotientSystem", IsLpGroup and
		  HasIsInvariantLPresentation and IsInvariantLPresentation);


############################################################################
##
#A  NilpotentQuotients
##
## For non-invariant L-presented groups the nilpotent quotients and the 
## corresponding epimorphisms are stored in this Attribute.
##
DeclareAttribute( "NilpotentQuotients", IsLpGroup );


############################################################################
##
#F  NQL_LCS( <QS> )
##
## Computes the lower central series of the nilpotent quotient given by a 
## quotient system <QS>.
##
DeclareGlobalFunction("NQL_LCS");

############################################################################
##
#A  LargestNilpotentQuotient( <LpGroup> )
##
##  Determines a polycyclic presentation for the largest nilpotent quotient
##  of a given L-presented group <LpGroup>.
##
DeclareAttribute("LargestNilpotentQuotient", IsLpGroup );
